## cruft-ng 0.2

=== Makefile ===
CXXFLAGS ?= -O2
CXXFLAGS += -Wall

all: cruft-ng
tests: test_mlocate test_explain test_filters cruftlib

cruft.o: cruft.cc explain.h filters.h mlocate.h dpkg.h
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) -c cruft.cc

%.o: %.cc %.h
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) -c $<

dpkg_lib.o: dpkg_lib.cc dpkg.h
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) -c dpkg_lib.cc

dpkg_popen.o: dpkg_popen.cc dpkg.h
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) -c dpkg_popen.cc

shellexp.o: shellexp.c
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) -c shellexp.c

cruft-ng: cruft.o explain.o filters.o mlocate.o dpkg_popen.o shellexp.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) cruft.o explain.o filters.o mlocate.o dpkg_popen.o shellexp.o -o cruft-ng

cruftlib: cruft.o explain.o filters.o mlocate.o dpkg_lib.o shellexp.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) cruft.o explain.o filters.o mlocate.o dpkg_lib.o   shellexp.o -o cruftlib

test_%: %.o test_%.cc dpkg_popen.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $< $@.cc dpkg_popen.o -o $@
test_mlocate: mlocate.o test_mlocate.cc
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $< $@.cc -o $@

install: all
	#install -D -m 2755 -g mlocate cruft-ng   $(DESTDIR)/usr/bin/cruft-ng
	install -D -m 0755            cruft-ng   $(DESTDIR)/usr/bin/cruft-ng
	install -D -m 0644            cruft-ng.8 $(DESTDIR)/usr/share/man/man8/cruft-ng.8
	install -D -m 0644            README.md  $(DESTDIR)/usr/share/doc/cruft-ng/README.md

clean:
	rm -f cruft-ng cruftlib test_mlocate test_filters test_explain
	rm -f *.o

=== debian/changelog ===
cruft-ng (0.2) unstable; urgency=medium

  * Fix license of mlocate_db.h in d/copyright
  * fail immediatly if can't read mlocate's db
  * enable hardening

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Wed, 29 Apr 2015 14:48:56 +0200

cruft-ng (0.1) unstable; urgency=medium

  * Initial release. (Closes: #770445)

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Sun, 23 Nov 2014 14:05:29 +0200

## cruft-ng 0.3

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-CXXFLAGS ?= -O2
+CXXFLAGS ?= -O2 -fstack-protector-strong -Wformat -Werror=format-security -Wl,-z,relro -D_FORTIFY_SOURCE=2
 CXXFLAGS += -Wall
 
 all: cruft-ng

=== debian/changelog ===
cruft-ng (0.3) unstable; urgency=medium

  * Fix stack-smashing error, replace strcpy by strncpy (Closes: #783723)
  * Enable use of 'DEBUG' environment variable

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Mon, 04 May 2015 10:20:24 +0200

=== debian/control ===
Source: cruft-ng
Section: admin
Priority: optional
Maintainer: Alexandre Detiste <alexandre.detiste@gmail.com>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.6
Homepage: https://github.com/a-detiste/cruft-ng/
Vcs-Git: https://github.com/a-detiste/cruft-ng.git
Vcs-Browser: https://github.com/a-detiste/cruft-ng

Package: cruft-ng
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, mlocate,
          cruft (<< 0.9.20) | cruft-common
Description: program that finds any cruft built up on your system
 cruft-ng is a program to look over your system for anything that shouldn't
 be there, but is; or for anything that should be there, but isn't.
 .
 It bases most of its results on dpkg's & mlocate's databases.

## cruft-ng 0.4

=== Makefile ===
--- 
+++ 
@@ -28,7 +28,7 @@
 test_%: %.o test_%.cc dpkg_popen.o
 	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $< $@.cc dpkg_popen.o -o $@
 test_mlocate: mlocate.o test_mlocate.cc
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $< $@.cc -o $@
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) mlocate.o test_mlocate.cc -o $@
 
 install: all
 	#install -D -m 2755 -g mlocate cruft-ng   $(DESTDIR)/usr/bin/cruft-ng

=== debian/changelog ===
cruft-ng (0.4) unstable; urgency=medium

  * Enable DEBUG all over the place
  * Print DEBUG info to stderr
  * process uppercase files in /etc/cruft/filters/ like original cruft
  * process script files in /etc/cruft/explain/ like original cruft

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Mon, 11 May 2015 16:50:37 +0200

## cruft-ng 0.4.1

=== debian/changelog ===
cruft-ng (0.4.1) unstable; urgency=low

  * always ignore contents of /mnt & /srv
  * run on a single file (Closes: #432026), this is a very simple implementation
    that can be enhanced
  * depends on cruft-common instead of "cruft (<< 0.9.20) | cruft-common"

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Thu, 05 Nov 2015 23:52:51 +0100

## cruft-ng 0.4.2

=== debian/changelog ===
cruft-ng (0.4.2) unstable; urgency=low

  * revert ignoring /srv, let admin handle this with their custom rules
  * take into account dpkg's path-exclude configuration (Closes: #619086)

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Fri, 11 Dec 2015 13:04:38 +0100

## cruft-ng 0.4.3

=== Makefile ===
CXXFLAGS ?= -O2 -fstack-protector-strong -Wformat -Werror=format-security -Wl,-z,relro -D_FORTIFY_SOURCE=2
CXXFLAGS += -Wall
SHARED_OBJS = cruft.o dpkg_exclude.o explain.o filters.o mlocate.o shellexp.o

all: cruft-ng
tests: test_mlocate test_explain test_filters test_excludes cruftlib

cruft.o: cruft.cc explain.h filters.h mlocate.h dpkg.h
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) -c cruft.cc

%.o: %.cc %.h
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) -c $<

dpkg_lib.o: dpkg_lib.cc dpkg.h
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) -c dpkg_lib.cc

dpkg_popen.o: dpkg_popen.cc dpkg.h
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) -c dpkg_popen.cc

shellexp.o: shellexp.c
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) -c shellexp.c

cruft-ng: $(SHARED_OBJS) dpkg_popen.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $(SHARED_OBJS) dpkg_popen.o -o cruft-ng

cruftlib: $(SHARED_OBJS) dpkg_lib.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $(SHARED_OBJS) dpkg_lib.o   -o cruftlib

test_%: %.o test_%.cc dpkg_popen.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $< $@.cc dpkg_popen.o -o $@
test_mlocate: mlocate.o test_mlocate.cc
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) mlocate.o test_mlocate.cc -o $@
test_excludes: dpkg_exclude.o test_excludes.cc
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) dpkg_exclude.o test_excludes.cc -o $@

install: all
	#install -D -m 2755 -g mlocate cruft-ng   $(DESTDIR)/usr/bin/cruft-ng
	install -D -m 0755            cruft-ng   $(DESTDIR)/usr/bin/cruft-ng
	install -D -m 0644            cruft-ng.8 $(DESTDIR)/usr/share/man/man8/cruft-ng.8
	install -D -m 0644            README.md  $(DESTDIR)/usr/share/doc/cruft-ng/README.md

clean:
	rm -f cruft-ng cruftlib test_mlocate test_filters test_explain test_excludes
	rm -f *.o

=== debian/changelog ===
cruft-ng (0.4.3) unstable; urgency=low

  * don't report .pyc files if a .py file exist (Closes:  #366616)

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Wed, 06 Jan 2016 21:51:45 +0100

## cruft-ng 0.4.4~bpo8+1

=== debian/changelog ===
cruft-ng (0.4.4~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Paul Wise <pabs@debian.org>  Fri, 12 Feb 2016 13:00:30 +1100

cruft-ng (0.4.4) unstable; urgency=low

  * Add support for systems with UsrMerge

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Sun, 17 Jan 2016 21:16:43 +0100

## cruft-ng 0.4.4

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 CXXFLAGS ?= -O2 -fstack-protector-strong -Wformat -Werror=format-security -Wl,-z,relro -D_FORTIFY_SOURCE=2
 CXXFLAGS += -Wall
-SHARED_OBJS = cruft.o dpkg_exclude.o explain.o filters.o mlocate.o shellexp.o
+SHARED_OBJS = cruft.o dpkg_exclude.o explain.o filters.o mlocate.o shellexp.o usr_merge.o
 
 all: cruft-ng
 tests: test_mlocate test_explain test_filters test_excludes cruftlib
@@ -26,8 +26,8 @@
 cruftlib: $(SHARED_OBJS) dpkg_lib.o
 	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $(SHARED_OBJS) dpkg_lib.o   -o cruftlib
 
-test_%: %.o test_%.cc dpkg_popen.o
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $< $@.cc dpkg_popen.o -o $@
+test_%: %.o test_%.cc dpkg_popen.o usr_merge.o
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $< $@.cc dpkg_popen.o usr_merge.o -o $@
 test_mlocate: mlocate.o test_mlocate.cc
 	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) mlocate.o test_mlocate.cc -o $@
 test_excludes: dpkg_exclude.o test_excludes.cc

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
 Package: cruft-ng
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, mlocate,
-          cruft (<< 0.9.20) | cruft-common
+          cruft-common
 Description: program that finds any cruft built up on your system
  cruft-ng is a program to look over your system for anything that shouldn't
  be there, but is; or for anything that should be there, but isn't.

=== debian/rules ===
#!/usr/bin/make -f
#DH_VERBOSE = 1

%:
	dh $@ --parallel

## cruft-ng 0.4.5

=== debian/changelog ===
cruft-ng (0.4.5) unstable; urgency=low

  * Declare compliance with Policy 4.1.2
  * Enable full hardening
  * Only refresh mlocate database when needed
  * Switch to DebHelper 10
  * Handle filenames longer than 199 bytes (Closes: #867016),
    thanks to Stefan Bühler
  * set Rules-Requires-Root: no

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Fri, 08 Dec 2017 12:21:32 +0100

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,12 @@
 Section: admin
 Priority: optional
 Maintainer: Alexandre Detiste <alexandre.detiste@gmail.com>
-Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.6
+Build-Depends: debhelper (>= 10)
+Standards-Version: 4.1.2
 Homepage: https://github.com/a-detiste/cruft-ng/
 Vcs-Git: https://github.com/a-detiste/cruft-ng.git
 Vcs-Browser: https://github.com/a-detiste/cruft-ng
+Rules-Requires-Root: no
 
 Package: cruft-ng
 Architecture: any

## cruft-ng 0.4.6

=== debian/changelog ===
cruft-ng (0.4.6) unstable; urgency=medium

  * consider all intermediates subdirectories under /etc as OK
    if those contain some dpkg-managed files
  * Declare compliance with Policy 4.1.2

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Tue, 02 Jan 2018 10:17:32 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Alexandre Detiste <alexandre.detiste@gmail.com>
 Build-Depends: debhelper (>= 10)
-Standards-Version: 4.1.2
+Standards-Version: 4.1.3
 Homepage: https://github.com/a-detiste/cruft-ng/
 Vcs-Git: https://github.com/a-detiste/cruft-ng.git
 Vcs-Browser: https://github.com/a-detiste/cruft-ng

## cruft-ng 0.4.7

=== debian/changelog ===
cruft-ng (0.4.7) unstable; urgency=low

  * switch to debhelper compat level 11
  * drop our copy of db.h, use the one provided by mlocate instead
  * bump Standards-Version to 4.2.1, no further change needed

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Sat, 17 Nov 2018 18:09:58 +0100

=== debian/rules ===
#!/usr/bin/make -f
#DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

## cruft-ng 0.4.7build1

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 SHARED_OBJS = cruft.o dpkg_exclude.o explain.o filters.o mlocate.o shellexp.o usr_merge.o
 
 all: cruft-ng
-tests: test_mlocate test_explain test_filters test_excludes cruftlib
+tests: test_mlocate test_explain test_filters test_excludes test_dpkg cruftlib
 
 cruft.o: cruft.cc explain.h filters.h mlocate.h dpkg.h
 	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) -c cruft.cc
@@ -28,6 +28,8 @@
 
 test_%: %.o test_%.cc dpkg_popen.o usr_merge.o
 	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $< $@.cc dpkg_popen.o usr_merge.o -o $@
+test_dpkg: test_dpkg.cc dpkg_popen.o usr_merge.o
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) dpkg_popen.o usr_merge.o test_dpkg.cc -o $@
 test_mlocate: mlocate.o test_mlocate.cc
 	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) mlocate.o test_mlocate.cc -o $@
 test_excludes: dpkg_exclude.o test_excludes.cc
@@ -40,5 +42,5 @@
 	install -D -m 0644            README.md  $(DESTDIR)/usr/share/doc/cruft-ng/README.md
 
 clean:
-	rm -f cruft-ng cruftlib test_mlocate test_filters test_explain test_excludes
+	rm -f cruft-ng cruftlib test_mlocate test_explain test_filters test_excludes test_dpkg
 	rm -f *.o

=== debian/changelog ===
cruft-ng (0.4.7build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:37:07 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,10 @@
 Section: admin
 Priority: optional
 Maintainer: Alexandre Detiste <alexandre.detiste@gmail.com>
-Build-Depends: debhelper (>= 10)
-Standards-Version: 4.1.3
+Build-Depends:
+    debhelper (>= 11~),
+    mlocate (>= 0.26-3),
+Standards-Version: 4.2.1
 Homepage: https://github.com/a-detiste/cruft-ng/
 Vcs-Git: https://github.com/a-detiste/cruft-ng.git
 Vcs-Browser: https://github.com/a-detiste/cruft-ng

## cruft-ng 0.4.7+nmu1

=== debian/changelog ===
cruft-ng (0.4.7+nmu1) unstable; urgency=medium

  * Non-maintainer upload.
  * rebuild for mstrict-align

 -- root <root@loongson-pc>  Fri, 28 Jan 2022 11:06:32 +0800

## cruft-ng 0.4.8

=== debian/changelog ===
cruft-ng (0.4.8) unstable; urgency=low

  * Bump debhelper from old 11 to 12. [Debian Janitor]
  * Set debhelper-compat version in Build-Depends. [Debian Janitor]
  * Do not read /var/lib/dpkg/diversions directly,
    instead call "dpkg-divert --list". (like #944926)
  * bump Standards-Version to 4.5.0, no further change needed

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Tue, 19 May 2020 16:22:26 +0200

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Priority: optional
 Maintainer: Alexandre Detiste <alexandre.detiste@gmail.com>
 Build-Depends:
-    debhelper (>= 11~),
+    debhelper-compat (= 12),
     mlocate (>= 0.26-3),
-Standards-Version: 4.2.1
+Standards-Version: 4.5.0
 Homepage: https://github.com/a-detiste/cruft-ng/
 Vcs-Git: https://github.com/a-detiste/cruft-ng.git
 Vcs-Browser: https://github.com/a-detiste/cruft-ng

## cruft-ng 0.4.9

=== Makefile ===
--- 
+++ 
@@ -34,6 +34,8 @@
 	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) mlocate.o test_mlocate.cc -o $@
 test_excludes: dpkg_exclude.o test_excludes.cc
 	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) dpkg_exclude.o test_excludes.cc -o $@
+test_diversions: test_diversions.cc dpkg_popen.o usr_merge.o
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) test_diversions.cc dpkg_popen.o usr_merge.o -o $@
 
 install: all
 	#install -D -m 2755 -g mlocate cruft-ng   $(DESTDIR)/usr/bin/cruft-ng
@@ -42,5 +44,5 @@
 	install -D -m 0644            README.md  $(DESTDIR)/usr/share/doc/cruft-ng/README.md
 
 clean:
-	rm -f cruft-ng cruftlib test_mlocate test_explain test_filters test_excludes test_dpkg
+	rm -f cruft-ng cruftlib test_mlocate test_explain test_filters test_excludes test_dpkg test_diversions
 	rm -f *.o

=== debian/changelog ===
cruft-ng (0.4.9) unstable; urgency=low

  * /usr/include/mlocate/db.h has vanished,
    revert change of 0.4.7 (Closes: #975754)

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Thu, 03 Dec 2020 02:46:46 +0100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,7 @@
 Priority: optional
 Maintainer: Alexandre Detiste <alexandre.detiste@gmail.com>
 Build-Depends:
-    debhelper-compat (= 12),
-    mlocate (>= 0.26-3),
+    debhelper-compat (= 13),
 Standards-Version: 4.5.0
 Homepage: https://github.com/a-detiste/cruft-ng/
 Vcs-Git: https://github.com/a-detiste/cruft-ng.git

## cruft-ng 0.4.50

=== debian/changelog ===
cruft-ng (0.4.50) unstable; urgency=low

  * Also support plocate. (Closes: #976367)

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Sun, 22 Aug 2021 15:45:33 +0200

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
 
 Package: cruft-ng
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, mlocate,
+Depends: ${shlibs:Depends}, ${misc:Depends}, mlocate | plocate,
           cruft-common
 Description: program that finds any cruft built up on your system
  cruft-ng is a program to look over your system for anything that shouldn't

## cruft-ng 0.4.51

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 CXXFLAGS ?= -O2 -fstack-protector-strong -Wformat -Werror=format-security -Wl,-z,relro -D_FORTIFY_SOURCE=2
 CXXFLAGS += -Wall
-SHARED_OBJS = cruft.o dpkg_exclude.o explain.o filters.o mlocate.o shellexp.o usr_merge.o
+SHARED_OBJS = cruft.o dpkg_exclude.o explain.o filters.o mlocate.o plocate.o shellexp.o usr_merge.o
 
 all: cruft-ng
 tests: test_mlocate test_explain test_filters test_excludes test_dpkg cruftlib
@@ -32,6 +32,8 @@
 	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) dpkg_popen.o usr_merge.o test_dpkg.cc -o $@
 test_mlocate: mlocate.o test_mlocate.cc
 	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) mlocate.o test_mlocate.cc -o $@
+test_plocate: plocate.o test_plocate.cc
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) plocate.o test_plocate.cc -o $@
 test_excludes: dpkg_exclude.o test_excludes.cc
 	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) dpkg_exclude.o test_excludes.cc -o $@
 test_diversions: test_diversions.cc dpkg_popen.o usr_merge.o
@@ -44,5 +46,5 @@
 	install -D -m 0644            README.md  $(DESTDIR)/usr/share/doc/cruft-ng/README.md
 
 clean:
-	rm -f cruft-ng cruftlib test_mlocate test_explain test_filters test_excludes test_dpkg test_diversions
+	rm -f cruft-ng cruftlib test_mlocate test_plocate test_explain test_filters test_excludes test_dpkg test_diversions
 	rm -f *.o

=== debian/changelog ===
cruft-ng (0.4.51) unstable; urgency=medium

  * Drop depends on transitional mlocate package (Closes: #992742)

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Thu, 30 Dec 2021 21:22:59 +0100

=== debian/control ===
--- 
+++ 
@@ -12,8 +12,11 @@
 
 Package: cruft-ng
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, mlocate | plocate,
-          cruft-common
+Depends:
+  ${shlibs:Depends},
+  ${misc:Depends},
+  plocate,
+  cruft-common
 Description: program that finds any cruft built up on your system
  cruft-ng is a program to look over your system for anything that shouldn't
  be there, but is; or for anything that should be there, but isn't.

## cruft-ng 0.4.52

=== debian/changelog ===
cruft-ng (0.4.52) unstable; urgency=low

  * Fix build on Hurd
  * update Python3.x heuristic to also support Python3.xx (e.g. 3.10)
  * bump Standards-Version to 4.6.0, no change needed

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Mon, 18 Apr 2022 23:49:39 +0200

## cruft-ng 0.4.53

=== debian/changelog ===
cruft-ng (0.4.53) unstable; urgency=medium

  * Fix segmentation fault when custom dpkg overrides are defined
    (Closes: #1010362)

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Sun, 17 Jul 2022 01:25:30 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Alexandre Detiste <alexandre.detiste@gmail.com>
 Build-Depends:
     debhelper-compat (= 13),
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Homepage: https://github.com/a-detiste/cruft-ng/
 Vcs-Git: https://github.com/a-detiste/cruft-ng.git
 Vcs-Browser: https://github.com/a-detiste/cruft-ng

## cruft-ng 0.9.44

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 CXXFLAGS += -Wall
 SHARED_OBJS = cruft.o dpkg_exclude.o explain.o filters.o mlocate.o plocate.o shellexp.o usr_merge.o
 
-all: cruft-ng
+all: check cruft
 tests: test_mlocate test_explain test_filters test_excludes test_dpkg cruftlib
 
 cruft.o: cruft.cc explain.h filters.h mlocate.h dpkg.h
@@ -20,8 +20,8 @@
 shellexp.o: shellexp.c
 	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) -c shellexp.c
 
-cruft-ng: $(SHARED_OBJS) dpkg_popen.o
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $(SHARED_OBJS) dpkg_popen.o -o cruft-ng
+cruft: $(SHARED_OBJS) dpkg_popen.o
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $(SHARED_OBJS) dpkg_popen.o -o cruft
 
 cruftlib: $(SHARED_OBJS) dpkg_lib.o
 	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $(SHARED_OBJS) dpkg_lib.o   -o cruftlib
@@ -40,11 +40,20 @@
 	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) test_diversions.cc dpkg_popen.o usr_merge.o -o $@
 
 install: all
-	#install -D -m 2755 -g mlocate cruft-ng   $(DESTDIR)/usr/bin/cruft-ng
-	install -D -m 0755            cruft-ng   $(DESTDIR)/usr/bin/cruft-ng
-	install -D -m 0644            cruft-ng.8 $(DESTDIR)/usr/share/man/man8/cruft-ng.8
-	install -D -m 0644            README.md  $(DESTDIR)/usr/share/doc/cruft-ng/README.md
+	#install -D -m 2755 -g mlocate cruftg   $(DESTDIR)/usr/bin/cruft
+	install -D -m 0755            cruft   $(DESTDIR)/usr/bin/cruft
+	install -D -m 0644            cruft.8 $(DESTDIR)/usr/share/man/man8/cruft.8
+	install -D -m 0644            cruft.8 $(DESTDIR)/usr/share/man/man8/cruft-ng.8
+	install -D -m 0644            README.md  $(DESTDIR)/usr/share/doc/cruft/README.md
 
 clean:
-	rm -f cruft-ng cruftlib test_mlocate test_plocate test_explain test_filters test_excludes test_dpkg test_diversions
+	rm -f cruft cruftlib test_mlocate test_plocate test_explain test_filters test_excludes test_dpkg test_diversions
 	rm -f *.o
+
+check:
+	echo Checking for trailing whitespaces
+	grep -E -R -H " +$$" rules/ || true
+	! grep -E -R -q " +$$" rules/
+	echo Checking for trailing slashes
+	grep -E -R -H "/+$$" rules/ || true
+	! grep -E -R -q "/+$$" rules/

=== debian/changelog ===
cruft-ng (0.9.44) unstable; urgency=medium

  * salvages the explain scripts and filters from retired 'cruft-common'
  * provides 'cruft' transitional package
  * fix regression in diversion handling introduced while fixing #1010362

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Sun, 02 Oct 2022 06:24:54 +0200

cruft-ng (0.4.54) unstable; urgency=medium

  * UsrMerge rollout: also support /lib32 -> /usr/lib32
  * bump Standards-Version to 4.6.1.0, no further change needed
  * add lintian override "uses-dpkg-database-directly"

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Wed, 21 Sep 2022 19:16:21 +0200

=== debian/control ===
Source: cruft-ng
Section: admin
Priority: optional
Maintainer: Alexandre Detiste <alexandre.detiste@gmail.com>
Build-Depends:
    debhelper-compat (= 13),
Standards-Version: 4.6.1.0
Homepage: https://github.com/a-detiste/cruft-ng/
Vcs-Git: https://github.com/a-detiste/cruft-ng.git
Vcs-Browser: https://github.com/a-detiste/cruft-ng
Rules-Requires-Root: no

Package: cruft-ng
Architecture: any
Depends:
  ${shlibs:Depends},
  ${misc:Depends},
  plocate,
Breaks: cruft (<< 0.9.44~), cruft-common
Replaces: cruft (<< 0.9.44~), cruft-common
Description: program that finds any cruft built up on your system
 cruft-ng is a program to look over your system for anything that shouldn't
 be there, but is; or for anything that should be there, but isn't.
 .
 It bases most of its results on dpkg's & plocate's databases.

Package: cruft
Depends: cruft-ng, ${misc:Depends}
Architecture: all
Section: oldlibs
Description: transitional package
 This is a transitional package. It can safely be removed.

=== debian/rules ===
--- 
+++ 
@@ -5,3 +5,6 @@
 
 %:
 	dh $@
+
+override_dh_auto_install:
+	dh_auto_install --destdir=debian/cruft-ng

## cruft-ng 0.9.45

=== Makefile ===
CXXFLAGS ?= -O2 -fstack-protector-strong -Wformat -Werror=format-security -Wl,-z,relro -D_FORTIFY_SOURCE=2
CXXFLAGS += -Wall
SHARED_OBJS = cruft.o dpkg_exclude.o explain.o filters.o mlocate.o plocate.o shellexp.o usr_merge.o python.o

all: check cruft
tests: test_plocate test_explain test_filters test_excludes test_dpkg test_dpkg_lib test_python cruftold

cruft.o: cruft.cc explain.h filters.h mlocate.h dpkg.h python.h
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) -c cruft.cc

%.o: %.cc %.h
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) -c $<

dpkg_lib.o: dpkg_lib.cc dpkg.h
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) -c dpkg_lib.cc -ldpkg

dpkg_popen.o: dpkg_popen.cc dpkg.h
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) -c dpkg_popen.cc

shellexp.o: shellexp.c
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) -c shellexp.c

cruftold: $(SHARED_OBJS) dpkg_popen.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $(SHARED_OBJS) dpkg_popen.o -o cruftold

cruft: $(SHARED_OBJS) dpkg_lib.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $(SHARED_OBJS) dpkg_lib.o -ldpkg -o cruft

test_%: %.o test_%.cc dpkg_popen.o usr_merge.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $< $@.cc dpkg_popen.o usr_merge.o -o $@
test_dpkg: test_dpkg.cc dpkg_popen.o usr_merge.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) dpkg_popen.o test_dpkg.cc usr_merge.o -o $@
test_dpkg_lib: test_dpkg.cc dpkg_lib.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) dpkg_lib.o test_dpkg.cc usr_merge.o -ldpkg -o $@
test_mlocate: mlocate.o test_mlocate.cc
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) mlocate.o test_mlocate.cc -o $@
test_plocate: plocate.o python.o test_plocate.cc
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) plocate.o python.o test_plocate.cc -o $@
test_python: python.o test_python.cc
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) python.o test_python.cc -o $@
test_excludes: dpkg_exclude.o test_excludes.cc
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) dpkg_exclude.o test_excludes.cc -o $@
test_diversions: test_diversions.cc dpkg_popen.o usr_merge.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) test_diversions.cc dpkg_popen.o usr_merge.o -o $@

install: all
	#install -D -m 2755 -g mlocate cruftg   $(DESTDIR)/usr/bin/cruft
	install -D -m 0755            cruft   $(DESTDIR)/usr/bin/cruft
	install -D -m 0644            cruft.8 $(DESTDIR)/usr/share/man/man8/cruft.8
	install -D -m 0644            cruft.8 $(DESTDIR)/usr/share/man/man8/cruft-ng.8
	install -D -m 0644            README.md  $(DESTDIR)/usr/share/doc/cruft/README.md

clean:
	rm -f cruft cruftold test_mlocate test_plocate test_explain test_filters test_excludes test_dpkg test_dpkg_lib test_diversions test_python
	rm -f *.o

check:
	echo Checking for trailing whitespaces
	grep -E -R -H " +$$" rules/ || true
	! grep -E -R -q " +$$" rules/
	echo Checking for trailing slashes
	grep -E -R -H "/+$$" rules/ || true
	! grep -E -R -q "/+$$" rules/

=== debian/changelog ===
cruft-ng (0.9.45) unstable; urgency=medium

  * Rewrite most DPKG data acquisition using the
    official static C library (Closes: #944926).
    This also makes this tool much faster.
  * Adding a new build dependency on "libdpkg-dev"

  * Fix plocate invocation to also detect
    extraneous files without '.' in their name.
    Thank you Piotr Engelking (Closes: #1021297)

  * Add missing "closedir()" that leaded to
    file descriptor exhaustion.
  * Remove extraneous *.pyc filters, now built
    into the main engine
  * Misc changes to various embedded rules for:
     UsrMerge, (b)eid-archive, RabbitMQ, dpkg-cross,
     udisks2, virtualbox, util-linux, systemd.

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Sat, 08 Oct 2022 04:09:13 +0200

=== debian/control ===
--- 
+++ 
@@ -3,6 +3,7 @@
 Priority: optional
 Maintainer: Alexandre Detiste <alexandre.detiste@gmail.com>
 Build-Depends:
+    libdpkg-dev,
     debhelper-compat (= 13),
 Standards-Version: 4.6.1.0
 Homepage: https://github.com/a-detiste/cruft-ng/

## cruft-ng 0.9.47

=== Makefile ===
PKG_CONFIG ?= pkg-config
LIBDPKG_LIBS = $(shell $(PKG_CONFIG) --static --libs libdpkg)
LIBDPKG_CFLAGS = $(shell $(PKG_CONFIG) --static --cflags libdpkg)

CXXFLAGS ?= -O2 -fstack-protector-strong -Wformat -Werror=format-security -Wl,-z,relro -D_FORTIFY_SOURCE=2
CXXFLAGS += -Wall -Wextra
override CXXFLAGS += $(LIBDPKG_CFLAGS)
#CXXFLAGS += -std=c++17 #  clang++
SHARED_OBJS = cruft.o dpkg_exclude.o explain.o filters.o plocate.o shellexp.o usr_merge.o python.o owner.o bugs.o

all: cruft ruleset cpigs
tests: test_plocate test_explain test_filters test_excludes test_dpkg test_dpkg_old test_python cruftold

cpigs.o: cpigs.cc owner.h
owner.o: owner.cc owner.h
explain.o: explain.cc owner.h
filters.o: filters.cc owner.h

cruft.o: cruft.cc explain.h filters.h dpkg.h python.h
dpkg_lib.o: dpkg_lib.cc dpkg.h
dpkg_popen.o: dpkg_popen.cc dpkg.h

cruftold: $(SHARED_OBJS) dpkg_popen.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $(SHARED_OBJS) dpkg_popen.o -lstdc++fs -o cruftold
cruft: $(SHARED_OBJS) dpkg_lib.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $(SHARED_OBJS) dpkg_lib.o $(LIBDPKG_LIBS) -o cruft

cpigsold: cpigs.o explain.o filters.o plocate.o shellexp.o usr_merge.o python.o dpkg_popen.o owner.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) cpigs.o explain.o filters.o plocate.o shellexp.o usr_merge.o python.o dpkg_popen.o owner.o -lstdc++fs -o cpigsold
cpigs: cpigs.o explain.o filters.o plocate.o shellexp.o usr_merge.o python.o dpkg_lib.o owner.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) cpigs.o explain.o filters.o plocate.o shellexp.o usr_merge.o python.o dpkg_lib.o owner.o $(LIBDPKG_LIBS) -o cpigs

test_%: %.o test_%.cc dpkg_lib.o usr_merge.o $(LIBDPKG_LIBS)
test_dpkg_old: dpkg_popen.o test_dpkg.cc usr_merge.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) test_dpkg.cc usr_merge.o dpkg_popen.o -o test_dpkg_old
test_dpkg: dpkg_lib.o test_dpkg.cc usr_merge.o $(LIBDPKG_LIBS)
test_plocate: plocate.o python.o test_plocate.cc
test_python: python.o test_python.cc
test_excludes: dpkg_exclude.o test_excludes.cc
test_diversions: test_diversions.cc dpkg_popen.o usr_merge.o
test_explain: test_explain.cc explain.o dpkg_lib.o usr_merge.o owner.o $(LIBDPKG_LIBS)
test_filters: test_filters.cc filters.o dpkg_lib.o usr_merge.o owner.o $(LIBDPKG_LIBS)

clean:
	rm -f cpigs cruft cruftold ruleset test_plocate test_explain test_filters test_excludes test_dpkg test_dpkg_old test_diversions test_python test_bugs
	rm -f *.o

ruleset: rules/*
	echo Checking for trailing whitespaces
	grep -E -R -H " +$$" rules/ || true
	! grep -E -R -q " +$$" rules/
	./ruleset.sh

flow.png: flow.ditaa
	ditaa flow.ditaa flow.png

=== debian/changelog ===
cruft-ng (0.9.47) unstable; urgency=medium

  * new "dh-cruft" binary package: this DebHelper module is to be used
    by source package that wants to provide their own rules.
  * "cpigs" command now support the new '-c' and '-C' arguments
    to generate either a .csv dump of all the volatile files
    or with '-C' of the whole system also including static files.
  * "cpigs" now also support the new '-e' command switch
    to export data in the format expected by NCDU (Closes: #291823)
  * list loose files with known bug numbers in "cruft" report.
    These bugs needs to be tagged with
    user = "cruft-ng@packages.debian.org" and tag = "cruft".
  * keep an archive of old rules and make the package easier
    to backport.
  * remove misleading "broken symlinks" in the report,
    it is not implemented (Closes: #1022890).
  * many performance improvements by Christian Göttsche

  * new rules provided by Christian Göttsche (Closes: #1022542):
    ccache, grub-efi-*, fwupd, kde-config-sddm, pbuilder, rkhunter,
    policycoreutils-dev, tlp, usbguard, vnstat
  * update explain scripts: UCF, ispell
  * update ruleset for Python3, apt, dpkg, openssh, util-linux,
    emacs, xemacs21
  * misc. new rules for: acpid, fail2ban, tix, lynx, powertop, uwf, piuparts,
    debci, debian-reference-*, server-xorg-legacy, synaptic, libgvc6, anacron,
    nginx, fai-quickstart, pcutils, keyboard-configuration, acct,
    installation-report, keyboard-configuration, dialog
  * replace php7.4 by php8.1

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Tue, 01 Nov 2022 20:56:28 +0100

cruft-ng (0.9.46) unstable; urgency=medium

  [ Alexandre Detiste ]
  * implement config file for ignore (Closes: #509414)
  * new companion program "cpigs" that works similar
    to "dpigs" from Debian Goodies package,
    but will instead list the dynamic file usage.
  * DPKG data acquisition: also consider packages in 'rc' state
  * workaround for plocate's default "PRUNEPATH=/var/spool":
    always scan these files ourselves
  * work almost as good as non-root, suppress warnings
  * new LOGROTATE generic handling script
  * pack all the rules into a single file
  * update ruleset for Jupyter, npm, base-files,
    libdbus-1dev, timgm6mb-soundfont, dlocate,
    systemd, init-system-helpers, PolicyKit,
    avahi-autoipd, redis-tools, iperf3.

  [ Guillem Jover ]
  * various build system improvement
  * add build dependency on pkg-config to fetch libdpkg flags
  * build: Remove unnecessary explicit make rules

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Wed, 19 Oct 2022 02:47:52 +0200

=== debian/tests/control ===
Tests: basic
Restrictions: needs-root

## cruft-ng 0.9.48

=== Makefile ===
--- 
+++ 
@@ -21,7 +21,7 @@
 dpkg_popen.o: dpkg_popen.cc dpkg.h
 
 cruftold: $(SHARED_OBJS) dpkg_popen.o
-	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $(SHARED_OBJS) dpkg_popen.o -lstdc++fs -o cruftold
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $(SHARED_OBJS) dpkg_popen.o -lstdc++fs -lpthread -o cruftold
 cruft: $(SHARED_OBJS) dpkg_lib.o
 	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $(SHARED_OBJS) dpkg_lib.o $(LIBDPKG_LIBS) -o cruft

=== debian/changelog ===
cruft-ng (0.9.48) unstable; urgency=medium

  * rewrite last script that needed the "file" command
    (Closes: #1023336, #1024168)
  * many more performance improvements by Christian Göttsche
  * add rules for: firebird3.0-server

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Fri, 18 Nov 2022 11:38:34 +0100

=== debian/control ===
--- 
+++ 
@@ -3,6 +3,7 @@
 Priority: optional
 Maintainer: Alexandre Detiste <alexandre.detiste@gmail.com>
 Build-Depends:
+    pkg-config,
     libdpkg-dev,
     debhelper-compat (= 13),
 Standards-Version: 4.6.1.0
@@ -17,13 +18,40 @@
   ${shlibs:Depends},
   ${misc:Depends},
   plocate,
+Suggests:
+  ncdu,
 Breaks: cruft (<< 0.9.44~), cruft-common
 Replaces: cruft (<< 0.9.44~), cruft-common
-Description: program that finds any cruft built up on your system
+Description: programs that helps analyse volatile "cruft" files on your system
  cruft-ng is a program to look over your system for anything that shouldn't
- be there, but is; or for anything that should be there, but isn't.
+ be there, but is - the so called "cruft";  or for anything
+ that should be there, but isn't.
  .
- It bases most of its results on dpkg's & plocate's databases.
+ cpigs is a program that by default it works like dpigs
+ but for volatile data. it prints out the package with the most volatile
+ data (usually apt, plocate...)
+ It can also dump it's whole state into a .csv format usable for
+ more in depth analysis.
+ .
+ Both cruft-ng and cpigs base most of their results on
+ dpkg's & plocate's databases, and also use a built-in custom
+ homegrown ruleset to match volatile files
+ to the corresponding engine.
+ .
+ Packages wanting to document such volatile files can do so
+ using dh-cruft.
+
+#Package: dh-cruft
+#Depends: ${perl:Depends}, ${misc:Depends}
+#Architecture: all
+#Provides: dh-sequence-cruft
+#Description: plugin for DebHelper to register .cruft and .purge files
+# While the files listed in debian/<package>.cruft will simply be
+# accounted for; the one in debian/<package>.purge will actually
+# be removed in the final purge step after package removal.
+# .
+# Some demo package can be found at:
+# https://github.com/a-detiste/dh-cruft-test
 
 Package: cruft
 Depends: cruft-ng, ${misc:Depends}

=== debian/rules ===
#!/usr/bin/make -f
#DH_VERBOSE = 1
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

ifeq ($(DEB_DISTRIBUTION),$(filter $(DEB_DISTRIBUTION),buster focal))
CPPFLAGS += -DBUSTER
override_dh_auto_build:
	./ruleset.sh buster
	make cruftold cpigsold
	mv cruftold cruft
	mv cpigsold cpigs
endif

override_dh_auto_install:
	dh_auto_install --destdir=debian/cruft-ng
#	mkdir -p debian/tmp/
#	pod2man --utf8 dh-cruft/dh_cruft debian/tmp/dh_cruft.1

override_dh_install:
	dh_install
#	sed -i 's/DH_CRUFT_VERSION/"$(DEB_VERSION)"/' debian/dh-cruft/usr/bin/dh_cruft
ifeq ($(DEB_DISTRIBUTION),$(filter $(DEB_DISTRIBUTION),buster focal))
	mkdir -p debian/cruft-ng/usr/lib/cruft/
	cp -a csv.py debian/cruft-ng/usr/lib/cruft/
	echo /var/lib/dpkg/info >> debian/cruft-ng/usr/share/cruft/ignore
endif

## cruft-ng 0.9.49

=== Makefile ===
PKG_CONFIG ?= pkg-config
LIBDPKG_LIBS = $(shell $(PKG_CONFIG) --static --libs libdpkg)
LIBDPKG_CFLAGS = $(shell $(PKG_CONFIG) --static --cflags libdpkg)

CXXFLAGS ?= -O2 -fstack-protector-strong -Wformat -Werror=format-security -Wl,-z,relro -D_FORTIFY_SOURCE=2
CXXFLAGS += -Wall -Wextra
override CXXFLAGS += $(LIBDPKG_CFLAGS)
#CXXFLAGS += -std=c++17 #  clang++
SHARED_OBJS = explain.o filters.o shellexp.o usr_merge.o python.o owner.o
CRUFT_OBJS = cruft.o dpkg_exclude.o bugs.o

sid: cruft ruleset cpigs
buster: cruftold cpigsold

tests: test_locate test_explain test_filters test_excludes test_dpkg test_dpkg_old test_python cruftold

cpigs.o: cpigs.cc owner.h
owner.o: owner.cc owner.h
explain.o: explain.cc owner.h
filters.o: filters.cc owner.h
plocate.o: plocate.cc locate.h
mlocate.o: mlocate.cc locate.h

cruft.o: cruft.cc explain.h filters.h dpkg.h python.h
dpkg_lib.o: dpkg_lib.cc dpkg.h
dpkg_popen.o: dpkg_popen.cc dpkg.h

cruftold: $(SHARED_OBJS) $(CRUFT_OBJS) mlocate.o dpkg_popen.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $(SHARED_OBJS) $(CRUFT_OBJS) mlocate.o dpkg_popen.o -lstdc++fs -pthread -o cruftold
cruft: $(SHARED_OBJS) $(CRUFT_OBJS) plocate.o dpkg_lib.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $(SHARED_OBJS) $(CRUFT_OBJS) plocate.o dpkg_lib.o $(LIBDPKG_LIBS) -pthread -o cruft

cpigsold: $(SHARED_OBJS) cpigs.o mlocate.o dpkg_popen.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $(SHARED_OBJS) cpigs.o mlocate.o dpkg_popen.o -lstdc++fs -o cpigsold
cpigs: $(SHARED_OBJS) cpigs.o plocate.o dpkg_lib.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) $(SHARED_OBJS) cpigs.o plocate.o dpkg_lib.o $(LIBDPKG_LIBS) -o cpigs

test_%: %.o test_%.cc dpkg_lib.o usr_merge.o $(LIBDPKG_LIBS)
test_dpkg_old: dpkg_popen.o test_dpkg.cc usr_merge.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) test_dpkg.cc usr_merge.o dpkg_popen.o -o test_dpkg_old
test_dpkg: dpkg_lib.o test_dpkg.cc usr_merge.o $(LIBDPKG_LIBS)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) test_dpkg.cc usr_merge.o dpkg_lib.o $(LIBDPKG_LIBS) -Wl,--no-demangle -o test_dpkg

ifdef $(BUSTER):
test_locate: test_mlocate
else
test_locate: test_plocate
endif
test_mlocate: test_locate.cc mlocate.o python.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) test_locate.cc mlocate.o python.o -lstdc++fs -o test_mlocate
test_plocate: test_locate.cc plocate.o python.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(CPPFLAGS) test_locate.cc plocate.o python.o -o test_plocate

test_python: python.o test_python.cc
test_excludes: dpkg_exclude.o test_excludes.cc
test_diversions: test_diversions.cc dpkg_popen.o usr_merge.o
test_explain: test_explain.cc explain.o dpkg_lib.o usr_merge.o owner.o $(LIBDPKG_LIBS)
test_filters: test_filters.cc filters.o dpkg_lib.o usr_merge.o owner.o $(LIBDPKG_LIBS)

clean:
	rm -f cpigs cruft cruftold ruleset test_?locate test_explain test_filters test_excludes test_dpkg test_dpkg_old test_diversions test_python test_bugs
	rm -f *.o

ruleset: rules/*
	echo Checking for trailing whitespaces
	grep -E -R -H " +$$" rules/ || true
	! grep -E -R -q " +$$" rules/
	./ruleset.sh

flow.png: flow.ditaa
	ditaa flow.ditaa flow.png

=== debian/changelog ===
cruft-ng (0.9.49) unstable; urgency=medium

  * new "dh-cruft" binary package: this DebHelper module is to be used
    by source package that wants to provide their own rules.
  * fix build on Hurd, also add rules for "hurd" and "libc0.3" packages.
  * fix rule for dpkg-dev optional files handling
  * add rules for isc-dhcp-server, ap-hotspot, linux-sound-base,
    menu-xdg, sntp, watchdog, proftpd-basic
  * update rules for: lightdm, rabbitmq-server, logrotate, nfs*,
    fwupd, atfpd, nginx.
  * add filters for independent proprietary software:
    Grafana
  * add support for Kali Linux derivative, and Debian packages found
    in it's default toolkit: stunnel4, ntpsec, rwhod, blueman,
    openvpn, iodine, inetsim.
  * add support for BeagleBone derivative: bb-customizations,
    ti-pru-cgt-installer, doc-beaglebone-getting-started,
    bb-node-red-installer, cloud9.

  [ NicolasJamar ]
  * add/refresh filters for Debian: alsa-base, alsa-utils, apache2, bolt,
    chrome-gnome-shell, chrony, command-not-found, fwupd, gdm3,
    geoclue-2.0, grub-*, nfs-kernel-server, pcmciatuils, php-dbg,
    power-profiles-daemon, resolvconf, sane-utils, shim-signed,
    snmp-mibs-downloader, yaru-theme-iconn usbmuxd, pkgconf,
    gconf2, docker.io, containerd, phpmyadmin.
  * add filters only applicable to Ubuntu and derivatives:
    apport, flatpak, ubuntu-advantage-tools, ubuntu-fan,
    ubuntu-drivers-common, ubuntu-mono, ubuntu-release-upgrader,
    update-manager-core, update-notifier, whoopsie.
  * add filters only applicable to Pop_OS:
    kernelstub, pop-upgrade.
  * add filters for independent proprietary software:
    Microsoft Visual Code, MongoDB, Sublime Text, Teamviewer,
    VirtualBox extensions package.

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Sun, 01 Jan 2023 18:05:14 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Alexandre Detiste <alexandre.detiste@gmail.com>
 Build-Depends:
-    pkg-config,
+    pkgconf,
     libdpkg-dev,
     debhelper-compat (= 13),
 Standards-Version: 4.6.1.0
@@ -17,7 +17,7 @@
 Depends:
   ${shlibs:Depends},
   ${misc:Depends},
-  plocate,
+  ${dist:Depends},
 Suggests:
   ncdu,
 Breaks: cruft (<< 0.9.44~), cruft-common

=== debian/rules ===
#!/usr/bin/make -f
#DH_VERBOSE = 1
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifeq ($(DEB_DISTRIBUTION),$(filter $(DEB_DISTRIBUTION),bullseye))
export DEB_CPPFLAGS_MAINT_APPEND = -std=gnu++17
endif

ifeq ($(DEB_DISTRIBUTION),$(filter $(DEB_DISTRIBUTION),buster focal))
export DEB_CPPFLAGS_MAINT_APPEND = -DBUSTER
endif

ifeq ($(DEB_DISTRIBUTION),$(filter $(DEB_DISTRIBUTION),xenial))
export DEB_CPPFLAGS_MAINT_APPEND = -DBUSTER -std=gnu++1y
endif

%:
	dh $@

override_dh_auto_build:
	./ruleset.sh $(DEB_DISTRIBUTION)
ifeq ($(DEB_DISTRIBUTION),$(filter $(DEB_DISTRIBUTION),buster xenial focal))
	make cruftold cpigsold
	mv cruftold cruft
	mv cpigsold cpigs
else
	make cruft cpigs
endif


override_dh_gencontrol:
ifeq ($(DEB_DISTRIBUTION),$(filter $(DEB_DISTRIBUTION),buster xenial focal))
	dh_gencontrol -- -Vdist:Depends="mlocate"
else
	dh_gencontrol -- -Vdist:Depends="plocate"
endif

override_dh_auto_install:
	dh_auto_install --destdir=debian/cruft-ng
#	mkdir -p debian/tmp/
#	pod2man --utf8 dh-cruft/dh_cruft debian/tmp/dh_cruft.1

override_dh_install:
	dh_install
ifneq ($(DEB_DISTRIBUTION),$(filter $(DEB_DISTRIBUTION),xenial))
#	sed -i 's/DH_CRUFT_VERSION/"$(DEB_VERSION)"/' debian/dh-cruft/usr/bin/dh_cruft
endif
ifeq ($(DEB_DISTRIBUTION),$(filter $(DEB_DISTRIBUTION),buster xenial focal))
	mkdir -p debian/cruft-ng/usr/lib/cruft/
	cp -a csv.py debian/cruft-ng/usr/lib/cruft/
endif

## cruft-ng 0.9.52

=== debian/changelog ===
cruft-ng (0.9.52) unstable; urgency=medium

  * Fix FTBFS on buildd: separate -arch and -indep targets.

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Sat, 28 Jan 2023 13:28:04 +0100

cruft-ng (0.9.51) unstable; urgency=medium

  * New upload to Mentors, fixing copyright attribution of mlocate_db.h
    as hinted by FTP-Master.

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Fri, 27 Jan 2023 10:14:52 +0100

cruft-ng (0.9.50) unstable; urgency=medium

  * new "dh-cruft" binary package: this DebHelper module is to be used
    by source package that wants to provide their own rules.
  * update filters for: grafana, npm, python3-pip, cron*, debconf.
  * add support for nginx.deb from nginx.org.
  * ship documentation in .deb in ASCII and .png formats.

  [ Christian Göttsche ]
  * new filters for: dovecot, geoipupdate, php-fm, postfix,
    quassel-core, redis-server, rspamd, strongswan, unbound.

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Fri, 27 Jan 2023 10:11:08 +0100

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,10 @@
 Priority: optional
 Maintainer: Alexandre Detiste <alexandre.detiste@gmail.com>
 Build-Depends:
+    debhelper-compat (= 13),
+Build-Depends-Arch:
     pkgconf,
     libdpkg-dev,
-    debhelper-compat (= 13),
 Standards-Version: 4.6.1.0
 Homepage: https://github.com/a-detiste/cruft-ng/
 Vcs-Git: https://github.com/a-detiste/cruft-ng.git
@@ -41,17 +42,17 @@
  Packages wanting to document such volatile files can do so
  using dh-cruft.
 
-#Package: dh-cruft
-#Depends: ${perl:Depends}, ${misc:Depends}
-#Architecture: all
-#Provides: dh-sequence-cruft
-#Description: plugin for DebHelper to register .cruft and .purge files
-# While the files listed in debian/<package>.cruft will simply be
-# accounted for; the one in debian/<package>.purge will actually
-# be removed in the final purge step after package removal.
-# .
-# Some demo package can be found at:
-# https://github.com/a-detiste/dh-cruft-test
+Package: dh-cruft
+Depends: ${perl:Depends}, ${misc:Depends}
+Architecture: all
+Provides: dh-sequence-cruft
+Description: plugin for DebHelper to register .cruft and .purge files
+ While the files listed in debian/<package>.cruft will simply be
+ accounted for; the one in debian/<package>.purge will actually
+ be removed in the final purge step after package removal.
+ .
+ Some demo package can be found at:
+ https://github.com/a-detiste/dh-cruft-test
 
 Package: cruft
 Depends: cruft-ng, ${misc:Depends}

## cruft-ng 0.9.53

=== Makefile ===
--- 
+++ 
@@ -69,3 +69,10 @@
 
 flow.png: flow.ditaa
 	ditaa flow.ditaa flow.png
+
+doc: flow.png
+
+bugs: debian/changelog
+	./bugs.py > bugs
+
+release: doc bugs

=== debian/changelog ===
cruft-ng (0.9.53) unstable; urgency=medium

  * Use /usr/share/cruft/rules/ as location for new dh-cruft rules
    to avoid that every single package switching to dh-cruft would
    also need to Breaks+Replaces on old cruft-commnon. (See #1030024)
  * make dh-cruft Multi-Arch: foreign as hinted

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Mon, 30 Jan 2023 20:15:28 +0100

=== debian/control ===
--- 
+++ 
@@ -45,6 +45,7 @@
 Package: dh-cruft
 Depends: ${perl:Depends}, ${misc:Depends}
 Architecture: all
+Multi-Arch: foreign
 Provides: dh-sequence-cruft
 Description: plugin for DebHelper to register .cruft and .purge files
  While the files listed in debian/<package>.cruft will simply be
